package SDK

import (
	"fmt"
	YunIot "gogs.baozhida.cn/bzdadmin/YunIot_SDK"
	"testing"
)

//git add .
//git commit -m "1.2v"
//git push -u origin master

func TestYunIot(t *testing.T) {

	YunIot_r, err := YunIot.NewYunIot("192.168.11.112")
	if err != nil {
		panic(any(err))
	}
	// 获取设备信息
	// T_sn string 设备Sn
	Device_r, err := YunIot_r.GetDevice("2023468279548912")
	if err != nil {
		println("没找到SN")
	}
	fmt.Println(Device_r)

	// 获取设备列表
	// T_ProductID string 产品类型
	// T_sn string 设备Sn
	// T_online int 在线状态 0所有  1在线   2离线   3未激活
	// PageIndex int 页码
	// PageSize int  每页数量 默认为10
	DeviceList_r, err := YunIot_r.GetDeviceList("", "", 0, 0, 0)
	if err != nil {
		println(err)
	}
	fmt.Println(DeviceList_r)

	// 推送设备数据
	// T_sn string 设备Sn
	// T_data string 发送内容 json 数据
	err = YunIot_r.GetDevicePush("2023456942857102", "{\"AAAA\":[{\"BBBB\":[{\"name\":\"TempSet\",\"value\":\"266666\"}]}]}")
	if err != nil {
		println("推送失败！")
	} else {
		println("推送成功！")
	}

	// 获取设备数据
	// T_sn string 产品sn
	// T_jointTab string 参数  AAAA.CCCC 拼接符.
	// jsonFind string 条件 {"$or":[{"name":"TempSet"},{"value":"26"}]}
	// jsonSort string 排序  {"value": 1}
	// PageIndex int 页码
	// PageSize int  每页数量 默认为10
	DeviceData_r, err := YunIot_r.GetDeviceData("2023456942857102", "AAAA.CCCC", "", "", 0, 0)
	if err != nil {
		println(err)
	}
	for _, v := range DeviceData_r.List {
		d := v.(map[string]interface{})
		fmt.Println(d["name"], ":", d["value"])
	}

	// 获取产品
	// T_ProductID string 产品型号
	ProductType_r, err := YunIot_r.GetProductType("ujRXdIYz")
	if err != nil {
		println(err)
	}
	fmt.Println(ProductType_r)

	// 获取产品列表
	// T_uuid string 用户识别码（8位）
	// T_name string 产品名称
	ProductTypeList_r, err := YunIot_r.GetProductTypeList("", "")
	if err != nil {
		println(err)
	}
	for _, v := range ProductTypeList_r {
		fmt.Println(v)
	}

	//获取协议
	//T_ProductID string 产品型号
	ProductProt_r, err := YunIot_r.GetProductProt(31)
	if err != nil {
		println(err)
	}
	fmt.Println(ProductProt_r)

	//获取协议列表
	//T_uuid string 用户识别码（8位）
	//T_mode int 根据 网关列表
	//T_name string 产品名称
	ProductProtList_r, err := YunIot_r.GetProductProtList("", 0, "")
	if err != nil {
		println(err)
	}
	for _, v := range ProductProtList_r {
		fmt.Println(v)
	}

	//获取网关列表
	ProductModeList_r, err := YunIot_r.GetProductModeList()
	if err != nil {
		println(err)
	}
	for _, v := range ProductModeList_r {
		fmt.Println(v)
	}

}
